gtkmm: Gdk::DeviceTool Class Reference

gtkmm 4.11.3

Public Types | Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gdk::DeviceTool Class Reference

A physical tool associated to a Gdk::Device. More...

`#include <gdkmm/devicetool.h>`

Inheritance diagram for Gdk::DeviceTool:
[legend]

## Public Types
enum class | Type { Type::UNKNOWN , Type::PEN , Type::ERASER , Type::BRUSH , Type::PENCIL , Type::AIRBRUSH , Type::MOUSE , Type::LENS }
| Indicates the specific type of tool being used being a tablet. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| DeviceTool (DeviceTool && src) noexcept
DeviceTool & | operator= (DeviceTool && src) noexcept
| ~DeviceTool () noexcept override
GdkDeviceTool * | gobj ()
| Provides access to the underlying C GObject. More...
const GdkDeviceTool * | gobj () const
| Provides access to the underlying C GObject. More...
GdkDeviceTool * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
guint64 | get_serial () const
| Gets the serial number of this tool. More...
guint64 | get_hardware_id () const
| Gets the hardware ID of this tool, or 0 if it's not known. More...
Type | get_tool_type () const
| Gets the `Gdk::DeviceTool::Type` of the tool. More...
AxisFlags | get_axes () const
| Gets the axes of the tool. More...
Glib::PropertyProxy_ReadOnly< guint64 > | property_serial () const
| The serial number of the tool. More...
Glib::PropertyProxy_ReadOnly< Type > | property_tool_type () const
| The type of the tool. More...
Glib::PropertyProxy_ReadOnly< AxisFlags > | property_axes () const
| The axes of the tool. More...
Glib::PropertyProxy_ReadOnly< guint64 > | property_hardware_id () const
| The hardware ID of the tool. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gdk::DeviceTool > | wrap (GdkDeviceTool * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

A physical tool associated to a Gdk::Device.

Since gtkmm 3.94:

## Constructor & Destructor Documentation

## ◆ DeviceTool()

Gdk::DeviceTool::DeviceTool | ( | DeviceTool && | src | ) |
| noexcept

## ◆ ~DeviceTool()

Gdk::DeviceTool::~DeviceTool | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ get_axes()

AxisFlags Gdk::DeviceTool::get_axes | ( |  | ) | const

Gets the axes of the tool.

Returns
  The axes of tool.

## ◆ get_hardware_id()

guint64 Gdk::DeviceTool::get_hardware_id | ( |  | ) | const

Gets the hardware ID of this tool, or 0 if it's not known.

When non-zero, the identifier is unique for the given tool model, meaning that two identical tools will share the same hardware_id, but will have different serial numbers (see get_serial()).

This is a more concrete (and device specific) method to identify a `Gdk::DeviceTool` than get_tool_type(), as a tablet may support multiple devices with the same `Gdk::DeviceTool::Type`, but different hardware identifiers.

Returns
  The hardware identifier of this tool.

## ◆ get_serial()

guint64 Gdk::DeviceTool::get_serial | ( |  | ) | const

Gets the serial number of this tool.

This value can be used to identify a physical tool (eg. a tablet pen) across program executions.

Returns
  The serial ID for this tool.

## ◆ get_tool_type()

Type Gdk::DeviceTool::get_tool_type | ( |  | ) | const

Gets the `Gdk::DeviceTool::Type` of the tool.

Returns
  The physical type for this tool. This can be used to figure out what sort of pen is being used, such as an airbrush or a pencil.

## ◆ get_type()

static GType Gdk::DeviceTool::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GdkDeviceTool * Gdk::DeviceTool::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GdkDeviceTool * Gdk::DeviceTool::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GdkDeviceTool * Gdk::DeviceTool::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

DeviceTool & Gdk::DeviceTool::operator= | ( | DeviceTool && | src | ) |
| noexcept

## ◆ property_axes()

Glib::PropertyProxy_ReadOnly< AxisFlags > Gdk::DeviceTool::property_axes | ( |  | ) | const

The axes of the tool.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_hardware_id()

Glib::PropertyProxy_ReadOnly< guint64 > Gdk::DeviceTool::property_hardware_id | ( |  | ) | const

The hardware ID of the tool.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_serial()

Glib::PropertyProxy_ReadOnly< guint64 > Gdk::DeviceTool::property_serial | ( |  | ) | const

The serial number of the tool.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_tool_type()

Glib::PropertyProxy_ReadOnly< Type > Gdk::DeviceTool::property_tool_type | ( |  | ) | const

The type of the tool.

Default value: Gdk::DeviceTool::Type::UNKNOWN

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gdk::DeviceTool > wrap | ( | GdkDeviceTool * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.